"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetupMigration1683553925586 = void 0;
class SetupMigration1683553925586 {
    constructor() {
        this.name = 'SetupMigration1683553925586';
    }
    async up(queryRunner) {
        await queryRunner.query(`CREATE TABLE "scope_model" ("name" varchar PRIMARY KEY NOT NULL)`);
        await queryRunner.query(`CREATE TABLE "role_model" ("uuid" varchar PRIMARY KEY NOT NULL, "name" varchar NOT NULL)`);
        await queryRunner.query(`CREATE UNIQUE INDEX "IDX_df2ff801b57740d027c942334f" ON "role_model" ("name") `);
        await queryRunner.query(`CREATE TABLE "user_model" ("uuid" varchar PRIMARY KEY NOT NULL, "username" varchar NOT NULL, "password" varchar)`);
        await queryRunner.query(`CREATE UNIQUE INDEX "IDX_180abb555e21d4825693f11b94" ON "user_model" ("username") `);
        await queryRunner.query(`CREATE TABLE "token_model" ("token" varchar PRIMARY KEY NOT NULL, "expiresOn" datetime, "device" varchar, "userUuid" varchar)`);
        await queryRunner.query(`CREATE TABLE "key_model" ("uuid" varchar PRIMARY KEY NOT NULL, "use" varchar NOT NULL, "alg" varchar NOT NULL, "public_key" text NOT NULL, "private_key" text NOT NULL)`);
        await queryRunner.query(`CREATE TABLE "active_key_model" ("id" integer PRIMARY KEY AUTOINCREMENT NOT NULL, "use" varchar NOT NULL, "keyUuid" varchar)`);
        await queryRunner.query(`CREATE TABLE "role_model_scopes_scope_model" ("roleModelUuid" varchar NOT NULL, "scopeModelName" varchar NOT NULL, PRIMARY KEY ("roleModelUuid", "scopeModelName"))`);
        await queryRunner.query(`CREATE INDEX "IDX_f9bcfb53e221f55fffe76d9566" ON "role_model_scopes_scope_model" ("roleModelUuid") `);
        await queryRunner.query(`CREATE INDEX "IDX_40ca823e227f9c76cb07cbdbca" ON "role_model_scopes_scope_model" ("scopeModelName") `);
        await queryRunner.query(`CREATE TABLE "user_model_roles_role_model" ("userModelUuid" varchar NOT NULL, "roleModelUuid" varchar NOT NULL, PRIMARY KEY ("userModelUuid", "roleModelUuid"))`);
        await queryRunner.query(`CREATE INDEX "IDX_013a8f388c7121d66a25dc13c1" ON "user_model_roles_role_model" ("userModelUuid") `);
        await queryRunner.query(`CREATE INDEX "IDX_dc7d14d6beccedf8df39de0cb6" ON "user_model_roles_role_model" ("roleModelUuid") `);
        await queryRunner.query(`CREATE TABLE "token_model_scopes_scope_model" ("tokenModelToken" varchar NOT NULL, "scopeModelName" varchar NOT NULL, PRIMARY KEY ("tokenModelToken", "scopeModelName"))`);
        await queryRunner.query(`CREATE INDEX "IDX_eae199f8e25d1860598be961e8" ON "token_model_scopes_scope_model" ("tokenModelToken") `);
        await queryRunner.query(`CREATE INDEX "IDX_3d94644f4da2c0d34b8e409009" ON "token_model_scopes_scope_model" ("scopeModelName") `);
        await queryRunner.query(`CREATE TABLE "token_model_roles_role_model" ("tokenModelToken" varchar NOT NULL, "roleModelUuid" varchar NOT NULL, PRIMARY KEY ("tokenModelToken", "roleModelUuid"))`);
        await queryRunner.query(`CREATE INDEX "IDX_29cb7647f58fc7cf48a87a57f0" ON "token_model_roles_role_model" ("tokenModelToken") `);
        await queryRunner.query(`CREATE INDEX "IDX_8d393cfb87d9f600ea660b16fa" ON "token_model_roles_role_model" ("roleModelUuid") `);
        await queryRunner.query(`CREATE TABLE "temporary_token_model" ("token" varchar PRIMARY KEY NOT NULL, "expiresOn" datetime, "device" varchar, "userUuid" varchar, CONSTRAINT "FK_2bd73082743f5f721e92a3ee109" FOREIGN KEY ("userUuid") REFERENCES "user_model" ("uuid") ON DELETE NO ACTION ON UPDATE NO ACTION)`);
        await queryRunner.query(`INSERT INTO "temporary_token_model"("token", "expiresOn", "device", "userUuid") SELECT "token", "expiresOn", "device", "userUuid" FROM "token_model"`);
        await queryRunner.query(`DROP TABLE "token_model"`);
        await queryRunner.query(`ALTER TABLE "temporary_token_model" RENAME TO "token_model"`);
        await queryRunner.query(`CREATE TABLE "temporary_active_key_model" ("id" integer PRIMARY KEY AUTOINCREMENT NOT NULL, "use" varchar NOT NULL, "keyUuid" varchar, CONSTRAINT "FK_b22053e2e4c267713fbd8e1f241" FOREIGN KEY ("keyUuid") REFERENCES "key_model" ("uuid") ON DELETE NO ACTION ON UPDATE NO ACTION)`);
        await queryRunner.query(`INSERT INTO "temporary_active_key_model"("id", "use", "keyUuid") SELECT "id", "use", "keyUuid" FROM "active_key_model"`);
        await queryRunner.query(`DROP TABLE "active_key_model"`);
        await queryRunner.query(`ALTER TABLE "temporary_active_key_model" RENAME TO "active_key_model"`);
        await queryRunner.query(`DROP INDEX "IDX_f9bcfb53e221f55fffe76d9566"`);
        await queryRunner.query(`DROP INDEX "IDX_40ca823e227f9c76cb07cbdbca"`);
        await queryRunner.query(`CREATE TABLE "temporary_role_model_scopes_scope_model" ("roleModelUuid" varchar NOT NULL, "scopeModelName" varchar NOT NULL, CONSTRAINT "FK_f9bcfb53e221f55fffe76d95669" FOREIGN KEY ("roleModelUuid") REFERENCES "role_model" ("uuid") ON DELETE CASCADE ON UPDATE CASCADE, CONSTRAINT "FK_40ca823e227f9c76cb07cbdbcad" FOREIGN KEY ("scopeModelName") REFERENCES "scope_model" ("name") ON DELETE CASCADE ON UPDATE CASCADE, PRIMARY KEY ("roleModelUuid", "scopeModelName"))`);
        await queryRunner.query(`INSERT INTO "temporary_role_model_scopes_scope_model"("roleModelUuid", "scopeModelName") SELECT "roleModelUuid", "scopeModelName" FROM "role_model_scopes_scope_model"`);
        await queryRunner.query(`DROP TABLE "role_model_scopes_scope_model"`);
        await queryRunner.query(`ALTER TABLE "temporary_role_model_scopes_scope_model" RENAME TO "role_model_scopes_scope_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_f9bcfb53e221f55fffe76d9566" ON "role_model_scopes_scope_model" ("roleModelUuid") `);
        await queryRunner.query(`CREATE INDEX "IDX_40ca823e227f9c76cb07cbdbca" ON "role_model_scopes_scope_model" ("scopeModelName") `);
        await queryRunner.query(`DROP INDEX "IDX_013a8f388c7121d66a25dc13c1"`);
        await queryRunner.query(`DROP INDEX "IDX_dc7d14d6beccedf8df39de0cb6"`);
        await queryRunner.query(`CREATE TABLE "temporary_user_model_roles_role_model" ("userModelUuid" varchar NOT NULL, "roleModelUuid" varchar NOT NULL, CONSTRAINT "FK_013a8f388c7121d66a25dc13c19" FOREIGN KEY ("userModelUuid") REFERENCES "user_model" ("uuid") ON DELETE CASCADE ON UPDATE CASCADE, CONSTRAINT "FK_dc7d14d6beccedf8df39de0cb6e" FOREIGN KEY ("roleModelUuid") REFERENCES "role_model" ("uuid") ON DELETE NO ACTION ON UPDATE NO ACTION, PRIMARY KEY ("userModelUuid", "roleModelUuid"))`);
        await queryRunner.query(`INSERT INTO "temporary_user_model_roles_role_model"("userModelUuid", "roleModelUuid") SELECT "userModelUuid", "roleModelUuid" FROM "user_model_roles_role_model"`);
        await queryRunner.query(`DROP TABLE "user_model_roles_role_model"`);
        await queryRunner.query(`ALTER TABLE "temporary_user_model_roles_role_model" RENAME TO "user_model_roles_role_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_013a8f388c7121d66a25dc13c1" ON "user_model_roles_role_model" ("userModelUuid") `);
        await queryRunner.query(`CREATE INDEX "IDX_dc7d14d6beccedf8df39de0cb6" ON "user_model_roles_role_model" ("roleModelUuid") `);
        await queryRunner.query(`DROP INDEX "IDX_eae199f8e25d1860598be961e8"`);
        await queryRunner.query(`DROP INDEX "IDX_3d94644f4da2c0d34b8e409009"`);
        await queryRunner.query(`CREATE TABLE "temporary_token_model_scopes_scope_model" ("tokenModelToken" varchar NOT NULL, "scopeModelName" varchar NOT NULL, CONSTRAINT "FK_eae199f8e25d1860598be961e86" FOREIGN KEY ("tokenModelToken") REFERENCES "token_model" ("token") ON DELETE CASCADE ON UPDATE CASCADE, CONSTRAINT "FK_3d94644f4da2c0d34b8e4090096" FOREIGN KEY ("scopeModelName") REFERENCES "scope_model" ("name") ON DELETE CASCADE ON UPDATE CASCADE, PRIMARY KEY ("tokenModelToken", "scopeModelName"))`);
        await queryRunner.query(`INSERT INTO "temporary_token_model_scopes_scope_model"("tokenModelToken", "scopeModelName") SELECT "tokenModelToken", "scopeModelName" FROM "token_model_scopes_scope_model"`);
        await queryRunner.query(`DROP TABLE "token_model_scopes_scope_model"`);
        await queryRunner.query(`ALTER TABLE "temporary_token_model_scopes_scope_model" RENAME TO "token_model_scopes_scope_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_eae199f8e25d1860598be961e8" ON "token_model_scopes_scope_model" ("tokenModelToken") `);
        await queryRunner.query(`CREATE INDEX "IDX_3d94644f4da2c0d34b8e409009" ON "token_model_scopes_scope_model" ("scopeModelName") `);
        await queryRunner.query(`DROP INDEX "IDX_29cb7647f58fc7cf48a87a57f0"`);
        await queryRunner.query(`DROP INDEX "IDX_8d393cfb87d9f600ea660b16fa"`);
        await queryRunner.query(`CREATE TABLE "temporary_token_model_roles_role_model" ("tokenModelToken" varchar NOT NULL, "roleModelUuid" varchar NOT NULL, CONSTRAINT "FK_29cb7647f58fc7cf48a87a57f0a" FOREIGN KEY ("tokenModelToken") REFERENCES "token_model" ("token") ON DELETE CASCADE ON UPDATE CASCADE, CONSTRAINT "FK_8d393cfb87d9f600ea660b16fa4" FOREIGN KEY ("roleModelUuid") REFERENCES "role_model" ("uuid") ON DELETE CASCADE ON UPDATE CASCADE, PRIMARY KEY ("tokenModelToken", "roleModelUuid"))`);
        await queryRunner.query(`INSERT INTO "temporary_token_model_roles_role_model"("tokenModelToken", "roleModelUuid") SELECT "tokenModelToken", "roleModelUuid" FROM "token_model_roles_role_model"`);
        await queryRunner.query(`DROP TABLE "token_model_roles_role_model"`);
        await queryRunner.query(`ALTER TABLE "temporary_token_model_roles_role_model" RENAME TO "token_model_roles_role_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_29cb7647f58fc7cf48a87a57f0" ON "token_model_roles_role_model" ("tokenModelToken") `);
        await queryRunner.query(`CREATE INDEX "IDX_8d393cfb87d9f600ea660b16fa" ON "token_model_roles_role_model" ("roleModelUuid") `);
    }
    async down(queryRunner) {
        await queryRunner.query(`DROP INDEX "IDX_8d393cfb87d9f600ea660b16fa"`);
        await queryRunner.query(`DROP INDEX "IDX_29cb7647f58fc7cf48a87a57f0"`);
        await queryRunner.query(`ALTER TABLE "token_model_roles_role_model" RENAME TO "temporary_token_model_roles_role_model"`);
        await queryRunner.query(`CREATE TABLE "token_model_roles_role_model" ("tokenModelToken" varchar NOT NULL, "roleModelUuid" varchar NOT NULL, PRIMARY KEY ("tokenModelToken", "roleModelUuid"))`);
        await queryRunner.query(`INSERT INTO "token_model_roles_role_model"("tokenModelToken", "roleModelUuid") SELECT "tokenModelToken", "roleModelUuid" FROM "temporary_token_model_roles_role_model"`);
        await queryRunner.query(`DROP TABLE "temporary_token_model_roles_role_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_8d393cfb87d9f600ea660b16fa" ON "token_model_roles_role_model" ("roleModelUuid") `);
        await queryRunner.query(`CREATE INDEX "IDX_29cb7647f58fc7cf48a87a57f0" ON "token_model_roles_role_model" ("tokenModelToken") `);
        await queryRunner.query(`DROP INDEX "IDX_3d94644f4da2c0d34b8e409009"`);
        await queryRunner.query(`DROP INDEX "IDX_eae199f8e25d1860598be961e8"`);
        await queryRunner.query(`ALTER TABLE "token_model_scopes_scope_model" RENAME TO "temporary_token_model_scopes_scope_model"`);
        await queryRunner.query(`CREATE TABLE "token_model_scopes_scope_model" ("tokenModelToken" varchar NOT NULL, "scopeModelName" varchar NOT NULL, PRIMARY KEY ("tokenModelToken", "scopeModelName"))`);
        await queryRunner.query(`INSERT INTO "token_model_scopes_scope_model"("tokenModelToken", "scopeModelName") SELECT "tokenModelToken", "scopeModelName" FROM "temporary_token_model_scopes_scope_model"`);
        await queryRunner.query(`DROP TABLE "temporary_token_model_scopes_scope_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_3d94644f4da2c0d34b8e409009" ON "token_model_scopes_scope_model" ("scopeModelName") `);
        await queryRunner.query(`CREATE INDEX "IDX_eae199f8e25d1860598be961e8" ON "token_model_scopes_scope_model" ("tokenModelToken") `);
        await queryRunner.query(`DROP INDEX "IDX_dc7d14d6beccedf8df39de0cb6"`);
        await queryRunner.query(`DROP INDEX "IDX_013a8f388c7121d66a25dc13c1"`);
        await queryRunner.query(`ALTER TABLE "user_model_roles_role_model" RENAME TO "temporary_user_model_roles_role_model"`);
        await queryRunner.query(`CREATE TABLE "user_model_roles_role_model" ("userModelUuid" varchar NOT NULL, "roleModelUuid" varchar NOT NULL, PRIMARY KEY ("userModelUuid", "roleModelUuid"))`);
        await queryRunner.query(`INSERT INTO "user_model_roles_role_model"("userModelUuid", "roleModelUuid") SELECT "userModelUuid", "roleModelUuid" FROM "temporary_user_model_roles_role_model"`);
        await queryRunner.query(`DROP TABLE "temporary_user_model_roles_role_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_dc7d14d6beccedf8df39de0cb6" ON "user_model_roles_role_model" ("roleModelUuid") `);
        await queryRunner.query(`CREATE INDEX "IDX_013a8f388c7121d66a25dc13c1" ON "user_model_roles_role_model" ("userModelUuid") `);
        await queryRunner.query(`DROP INDEX "IDX_40ca823e227f9c76cb07cbdbca"`);
        await queryRunner.query(`DROP INDEX "IDX_f9bcfb53e221f55fffe76d9566"`);
        await queryRunner.query(`ALTER TABLE "role_model_scopes_scope_model" RENAME TO "temporary_role_model_scopes_scope_model"`);
        await queryRunner.query(`CREATE TABLE "role_model_scopes_scope_model" ("roleModelUuid" varchar NOT NULL, "scopeModelName" varchar NOT NULL, PRIMARY KEY ("roleModelUuid", "scopeModelName"))`);
        await queryRunner.query(`INSERT INTO "role_model_scopes_scope_model"("roleModelUuid", "scopeModelName") SELECT "roleModelUuid", "scopeModelName" FROM "temporary_role_model_scopes_scope_model"`);
        await queryRunner.query(`DROP TABLE "temporary_role_model_scopes_scope_model"`);
        await queryRunner.query(`CREATE INDEX "IDX_40ca823e227f9c76cb07cbdbca" ON "role_model_scopes_scope_model" ("scopeModelName") `);
        await queryRunner.query(`CREATE INDEX "IDX_f9bcfb53e221f55fffe76d9566" ON "role_model_scopes_scope_model" ("roleModelUuid") `);
        await queryRunner.query(`ALTER TABLE "active_key_model" RENAME TO "temporary_active_key_model"`);
        await queryRunner.query(`CREATE TABLE "active_key_model" ("id" integer PRIMARY KEY AUTOINCREMENT NOT NULL, "use" varchar NOT NULL, "keyUuid" varchar)`);
        await queryRunner.query(`INSERT INTO "active_key_model"("id", "use", "keyUuid") SELECT "id", "use", "keyUuid" FROM "temporary_active_key_model"`);
        await queryRunner.query(`DROP TABLE "temporary_active_key_model"`);
        await queryRunner.query(`ALTER TABLE "token_model" RENAME TO "temporary_token_model"`);
        await queryRunner.query(`CREATE TABLE "token_model" ("token" varchar PRIMARY KEY NOT NULL, "expiresOn" datetime, "device" varchar, "userUuid" varchar)`);
        await queryRunner.query(`INSERT INTO "token_model"("token", "expiresOn", "device", "userUuid") SELECT "token", "expiresOn", "device", "userUuid" FROM "temporary_token_model"`);
        await queryRunner.query(`DROP TABLE "temporary_token_model"`);
        await queryRunner.query(`DROP INDEX "IDX_8d393cfb87d9f600ea660b16fa"`);
        await queryRunner.query(`DROP INDEX "IDX_29cb7647f58fc7cf48a87a57f0"`);
        await queryRunner.query(`DROP TABLE "token_model_roles_role_model"`);
        await queryRunner.query(`DROP INDEX "IDX_3d94644f4da2c0d34b8e409009"`);
        await queryRunner.query(`DROP INDEX "IDX_eae199f8e25d1860598be961e8"`);
        await queryRunner.query(`DROP TABLE "token_model_scopes_scope_model"`);
        await queryRunner.query(`DROP INDEX "IDX_dc7d14d6beccedf8df39de0cb6"`);
        await queryRunner.query(`DROP INDEX "IDX_013a8f388c7121d66a25dc13c1"`);
        await queryRunner.query(`DROP TABLE "user_model_roles_role_model"`);
        await queryRunner.query(`DROP INDEX "IDX_40ca823e227f9c76cb07cbdbca"`);
        await queryRunner.query(`DROP INDEX "IDX_f9bcfb53e221f55fffe76d9566"`);
        await queryRunner.query(`DROP TABLE "role_model_scopes_scope_model"`);
        await queryRunner.query(`DROP TABLE "active_key_model"`);
        await queryRunner.query(`DROP TABLE "key_model"`);
        await queryRunner.query(`DROP TABLE "token_model"`);
        await queryRunner.query(`DROP INDEX "IDX_180abb555e21d4825693f11b94"`);
        await queryRunner.query(`DROP TABLE "user_model"`);
        await queryRunner.query(`DROP INDEX "IDX_df2ff801b57740d027c942334f"`);
        await queryRunner.query(`DROP TABLE "role_model"`);
        await queryRunner.query(`DROP TABLE "scope_model"`);
    }
}
exports.SetupMigration1683553925586 = SetupMigration1683553925586;
//# sourceMappingURL=1683553925586-SetupMigration.js.map