"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.activeKeyRepository = exports.ActiveKeyRepository = void 0;
const model_1 = require("../model");
const keyRepository_1 = require("./keyRepository");
const service_common_1 = require("@crosslab/service-common");
class ActiveKeyRepository extends service_common_1.AbstractRepository {
    constructor() {
        super('Active Key');
    }
    initialize(AppDataSource) {
        this.repository = AppDataSource.getRepository(model_1.ActiveKeyModel);
    }
    async write(model, data) {
        model.use = data.use;
        model.key = await keyRepository_1.keyRepository.findOneOrFail({
            where: {
                uuid: data.key,
            },
        });
    }
    async format(_model) {
        return undefined;
    }
    getDefaultFindOptionsRelations() {
        return {
            key: true,
        };
    }
}
exports.ActiveKeyRepository = ActiveKeyRepository;
exports.activeKeyRepository = new ActiveKeyRepository();
//# sourceMappingURL=activeKeyRepository.js.map