"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.keyRepository = exports.KeyRepository = void 0;
const model_1 = require("../model");
const activeKeyRepository_1 = require("./activeKeyRepository");
const service_common_1 = require("@crosslab/service-common");
class KeyRepository extends service_common_1.AbstractRepository {
    constructor() {
        super('Key');
    }
    initialize(AppDataSource) {
        this.repository = AppDataSource.getRepository(model_1.KeyModel);
    }
    async write(model, data) {
        model.alg = data.alg;
        model.private_key = data.private_key;
        model.public_key = data.public_key;
        model.use = data.use;
    }
    async format(_model) {
        return undefined;
    }
    async remove(model) {
        if (!this.repository)
            this.throwUninitializedRepositoryError();
        const activeKeyModels = await activeKeyRepository_1.activeKeyRepository.find({
            where: {
                key: {
                    uuid: model.uuid,
                },
            },
        });
        for (const activeKeyModel of activeKeyModels) {
            await activeKeyRepository_1.activeKeyRepository.remove(activeKeyModel);
        }
        await this.repository.remove(model);
    }
}
exports.KeyRepository = KeyRepository;
exports.keyRepository = new KeyRepository();
//# sourceMappingURL=keyRepository.js.map