"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const operations_1 = __importDefault(require("../operations"));
const requestValidation_1 = require("./requestValidation");
const types_1 = require("./types");
const express_1 = __importDefault(require("express"));
function routes(options) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        const userDataEntries = [];
        for (const method in securityRequirement) {
            const user = await options.security[method](request, securityRequirement[method]);
            if (!(0, types_1.isUserType)(user))
                throw new Error(`User resolved by method ${method} is not of type 'UserType'`);
            userDataEntries.push([method, user]);
        }
        return Object.fromEntries(userDataEntries);
    }
    router.get('/auth', async (req, res, next) => {
        const parameters = {
            Authorization: req.get('Authorization'),
            'X-Real-IP': req.get('X-Real-IP'),
            'X-Forwarded-Proto': req.get('X-Forwarded-Proto'),
        };
        try {
            if (!(0, requestValidation_1.validateGetAuthInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetAuthInput.errors, 400);
            }
            const result = await operations_1.default.getAuth(parameters);
            if (!(0, requestValidation_1.validateGetAuthOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetAuthOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/login', async (req, res, next) => {
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostLoginInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostLoginInput.errors, 400);
            }
            const result = await operations_1.default.postLogin(body);
            if (!(0, requestValidation_1.validatePostLoginOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostLoginOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/logout', async (req, res, next) => {
        const security = [
            {
                JWT: ['logout'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostLogoutInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostLogoutInput.errors, 400);
            }
            const result = await operations_1.default.postLogout(body, userData);
            if (!(0, requestValidation_1.validatePostLogoutOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostLogoutOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/device_authentication_token', async (req, res, next) => {
        const security = [
            {
                JWT: [
                    'device_token',
                    'device_token:create',
                    'device_token:create:owned',
                    'device_token:create:instantiable',
                ],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_url: req.query['device_url'],
        };
        try {
            if (!(0, requestValidation_1.validatePostDeviceAuthenticationTokenInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostDeviceAuthenticationTokenInput.errors, 400);
            }
            const result = await operations_1.default.postDeviceAuthenticationToken(parameters, userData);
            if (!(0, requestValidation_1.validatePostDeviceAuthenticationTokenOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostDeviceAuthenticationTokenOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/users', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetUsersInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetUsersInput.errors, 400);
            }
            const result = await operations_1.default.getUsers(userData);
            if (!(0, requestValidation_1.validateGetUsersOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetUsersOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/users', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:create'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostUsersInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostUsersInput.errors, 400);
            }
            const result = await operations_1.default.postUsers(body, userData);
            if (!(0, requestValidation_1.validatePostUsersOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostUsersOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/users/:user_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            user_id: req.params['user_id'],
        };
        try {
            if (!(0, requestValidation_1.validateGetUsersByUserIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetUsersByUserIdInput.errors, 400);
            }
            const result = await operations_1.default.getUsersByUserId(parameters, userData);
            if (!(0, requestValidation_1.validateGetUsersByUserIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetUsersByUserIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/users/:user_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            user_id: req.params['user_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchUsersByUserIdInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchUsersByUserIdInput.errors, 400);
            }
            const result = await operations_1.default.patchUsersByUserId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchUsersByUserIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchUsersByUserIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/users/:user_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:delete'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            user_id: req.params['user_id'],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteUsersByUserIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteUsersByUserIdInput.errors, 400);
            }
            const result = await operations_1.default.deleteUsersByUserId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteUsersByUserIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteUsersByUserIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/users/:user_id/roles', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            user_id: req.params['user_id'],
        };
        try {
            if (!(0, requestValidation_1.validateGetUsersByUserIdRolesInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetUsersByUserIdRolesInput.errors, 400);
            }
            const result = await operations_1.default.getUsersByUserIdRoles(parameters, userData);
            if (!(0, requestValidation_1.validateGetUsersByUserIdRolesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetUsersByUserIdRolesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/users/:user_id/roles', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            user_id: req.params['user_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostUsersByUserIdRolesInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostUsersByUserIdRolesInput.errors, 400);
            }
            const result = await operations_1.default.postUsersByUserIdRoles(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostUsersByUserIdRolesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostUsersByUserIdRolesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/users/:user_id/roles', async (req, res, next) => {
        const security = [
            {
                JWT: ['users', 'users:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            user_id: req.params['user_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateDeleteUsersByUserIdRolesInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteUsersByUserIdRolesInput.errors, 400);
            }
            const result = await operations_1.default.deleteUsersByUserIdRoles(parameters, body, userData);
            if (!(0, requestValidation_1.validateDeleteUsersByUserIdRolesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteUsersByUserIdRolesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/roles', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetRolesInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetRolesInput.errors, 400);
            }
            const result = await operations_1.default.getRoles(userData);
            if (!(0, requestValidation_1.validateGetRolesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetRolesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/roles', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:create'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostRolesInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostRolesInput.errors, 400);
            }
            const result = await operations_1.default.postRoles(body, userData);
            if (!(0, requestValidation_1.validatePostRolesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostRolesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/roles/:role_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            role_id: req.params['role_id'],
        };
        try {
            if (!(0, requestValidation_1.validateGetRolesByRoleIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetRolesByRoleIdInput.errors, 400);
            }
            const result = await operations_1.default.getRolesByRoleId(parameters, userData);
            if (!(0, requestValidation_1.validateGetRolesByRoleIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetRolesByRoleIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/roles/:role_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            role_id: req.params['role_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchRolesByRoleIdInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchRolesByRoleIdInput.errors, 400);
            }
            const result = await operations_1.default.patchRolesByRoleId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchRolesByRoleIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchRolesByRoleIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/roles/:role_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:delete'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            role_id: req.params['role_id'],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteRolesByRoleIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteRolesByRoleIdInput.errors, 400);
            }
            const result = await operations_1.default.deleteRolesByRoleId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteRolesByRoleIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteRolesByRoleIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/roles/:role_id/users', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            role_id: req.params['role_id'],
        };
        try {
            if (!(0, requestValidation_1.validateGetRolesByRoleIdUsersInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetRolesByRoleIdUsersInput.errors, 400);
            }
            const result = await operations_1.default.getRolesByRoleIdUsers(parameters, userData);
            if (!(0, requestValidation_1.validateGetRolesByRoleIdUsersOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetRolesByRoleIdUsersOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/roles/:role_id/users', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            role_id: req.params['role_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostRolesByRoleIdUsersInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostRolesByRoleIdUsersInput.errors, 400);
            }
            const result = await operations_1.default.postRolesByRoleIdUsers(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostRolesByRoleIdUsersOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostRolesByRoleIdUsersOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/roles/:role_id/users', async (req, res, next) => {
        const security = [
            {
                JWT: ['roles', 'roles:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            role_id: req.params['role_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateDeleteRolesByRoleIdUsersInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteRolesByRoleIdUsersInput.errors, 400);
            }
            const result = await operations_1.default.deleteRolesByRoleIdUsers(parameters, body, userData);
            if (!(0, requestValidation_1.validateDeleteRolesByRoleIdUsersOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteRolesByRoleIdUsersOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/identity', async (req, res, next) => {
        const security = [
            {
                JWT: ['identity', 'identity:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetIdentityInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetIdentityInput.errors, 400);
            }
            const result = await operations_1.default.getIdentity(userData);
            if (!(0, requestValidation_1.validateGetIdentityOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetIdentityOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/identity', async (req, res, next) => {
        const security = [
            {
                JWT: ['identity', 'identity:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchIdentityInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchIdentityInput.errors, 400);
            }
            const result = await operations_1.default.patchIdentity(body, userData);
            if (!(0, requestValidation_1.validatePatchIdentityOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchIdentityOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/register', async (req, res, next) => {
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostRegisterInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostRegisterInput.errors, 400);
            }
            const result = await operations_1.default.postRegister(body);
            if (!(0, requestValidation_1.validatePostRegisterOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostRegisterOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map